100 ::
110 CLEAR: REMark ContourDemo2_bas INTERPOLATION by S.Poole v30nov92, v7oct24
120 REMark Just LRUN. (Hit 'n' to repeat a curve when paused).
130 dotss=9: prec=8: REMark Change the number of dots or the precision....
135 pr=0: IF pr: prec=8
140 :
150 REPeat LOOP
160 IF dotss<3: dotss=3: END IF : IF dotss>90: dotss=90
170 pmf=prec MOD 4: IF pmf: prec=prec-pmf
180 IF prec<4: prec=4: END IF : IF prec>40: prec=40
190 INIT: INK 7
200 TYPEM: DRAW: IF INKEY$(250)=='n': GO TO 200
210 END REPeat LOOP
220 :
230 DEFine PROCedure TYPEM
240 INK 4: oaz=0
250 REMark loop to calculate each bearing :
260 FOR f=1 TO dots+3
270 j=f+1: fj=j
280 xx=t(j,x)-t(f,x): yy=t(j,y)-t(f,y)
290 dd=SQRT(xx*xx+yy*yy)
300 sx=(xx>0)-(xx<0): sy=(yy>0)-(yy<0): IF dd=0: az=0: ELSE : az=ASIN(yy/dd): END IF
310 IF sx>=0: IF sy<0: az=Pw+az: END IF : ELSE : az=PI-az: END IF
320 IF (ABS(az)==RAD(45)) OR (0==(ABS(az)+1)) OR (oaz==az): t(j,y)=t(j,y)+1:::: GO TO 280: END IF
330 t(f,azt)=az: oaz=az
340 END FOR f
350 :
360 REMark loop to detect 'straight_ish' lines :
370 DIM pic(0),pic(dots+5,2)
380 FOR f=1 TO dots-2
390 az1=t(f,azt): az2=t(f+1,azt): az3=t(f+2,azt)
400 az4=t(f+3,azt): a5=RAD(15): za1=0: za2=0
410 SELect az1: =az2-a5 TO az2+a5: za1=1: pic(f+1,1)=2
420 SELect az3: =az4-a5 TO az4+a5: za2=1: pic(f+2,1)=3
430 IF za1 OR za2 THEN
440 REMark INK 7: CIRCLE t(f,x),t(f,y),2: INK 4
450 END IF
460 END FOR f
470 :
480 REMark Loop to Keep bearings in 'whole circle':
490 FOR f=2 TO dots+3
500 th=t(f,azt)-t(f-1,azt): IF th<-PI: th=th+Pw
510 IF th>PI: th=th-Pw
520 t(f,trn)=th
530 END FOR f: t(1,trn)=t(dots+1,trn)
540 :
550 REMark Loop to get the signs of the bearings :
560 FOR f=1 TO dots+3
570 t1=t(f,trn): t2=t(f+1,trn): s1=(t1>0)-(t1<0): s2=(t2>0)-(t2<0)
580 s$=sig$(s1+2)&sig$(s2+2)&' ': tp=s$ INSTR sg$
590 t(f,typ)=((tp+2)/3)-1
600 END FOR f: t(dots+4,typ)=t(4,typ)
610 END DEFine TYPEM
620 :
630 DEFine PROCedure DRAW
640 DIM TRg(dots+4)
650 REMark Loop to Consider the triangles linking successive dots :
660 FOR f=2 TO dots
670 REMark a,b & c refer to three successive dots :
680 a=f-1: b=a+1: c=b+1: bx=t(b,x): by=t(b,y): cx=t(c,x): cy=t(c,y)
690 abx=ax-bx: aby=ay-by: BCx=bx-cx: BCy=by-cy: acx=ax-cx: acy=ay-cy
700 as=SQRT(ax*ax+ay*ay): bs=SQRT(bx*bx+by*by): cs=SQRT(cx*cx+cy*cy)
710 IF 0<>(2*a*b): NC=ACOS((-(c*c-a*a-b*b)/(2*a*b))): ELSE NC=ACOS(0)
720 TRg(f)=NC
730 END FOR f: TRg(f+1)=TRg(f)
740 :
750 REMark Loop to determine how three successive dots are positioned :
760 FOR f=2 TO dots-1
770 omm=-9999: OVER 0
780 :
790 REMark See if angle is clockwise or anticlockwise :
800 t$=t(f,typ): CWs=t$ INSTR('06'): ACWs=t$ INSTR('28')
810 IF CWs THEN
820    IF pic(f,1)=2: t(f,typ)=3    : REMark half of a 'straightish' line.
830    IF pic(f+1,1)=3: t(f+1,typ)=1: REMark        idem
840 END IF
850 IF ACWs THEN
860    IF pic(f,1)=2: t(f,typ)=5    : REMark        idem
870    IF pic(f+1,1)=3: t(f+1,typ)=7: REMark        idem
880 END IF
890 INK 4
900 a=f-1: b=a+1: c=b+1: tipes=t(f,typ): bx=t(b,x): by=t(b,y): cx=t(c,x): cy=t(c,y)
910 REMark M indicates the mid-point :
920 BCx=bx-cx: BCy=by-cy: MCx=BCx/2: MCy=BCy/2: Mx=bx-MCx: My=by-MCy
930 REMark determine the azimuth of the bisextrice :
940 ab=t(b,azt): a1=(t(a,azt)+ab)/2: a2=(ab+t(c,azt))/2: a3=ab+Ph
950 POINT bx,by
960 :
970 REMark Matrix 'L' holds the coordinates for each curve-type :::::::::
980 SELect ON tipes
990 =0,3,7,8: L(1,1,x)=bx+COS(a1): L(1,1,y)=by+SIN(a1): L(1,4,x)=cx+COS(a2)
1000  L(1,4,y)=cy+SIN(a2): L(1,2,x)=bx: L(1,2,y)=by: L(1,3,x)=cx: L(1,3,y)=cy
1010 END SELect
1020 SELect ON tipes
1030 =1,2,6,7: L(2,1,x)=bx+COS(a1): L(2,1,y)=by+SIN(a1): L(2,4,x)=Mx+COS(a3)
1040 L(2,4,y)=My+SIN(a3): L(2,2,x)=bx: L(2,2,y)=by: L(2,3,x)=Mx: L(2,3,y)=My
1050 END SELect
1060 SELect ON tipes
1070 =2,3,5,6: L(3,1,x)=Mx+COS(a3): L(3,1,y)=My+SIN(a3): L(3,4,x)=cx+COS(a2)
1080 L(3,4,y)=cy+SIN(a2):  L(3,2,x)=Mx: L(3,2,y)=My: L(3,3,x)=cx: L(3,3,y)=cy
1090 END SELect
1100 : rc=10
1110 REMark determine which triangle(s) to choose for each curve type:
1120 SELect ON tipes
1130  =0: TRI 1,0
1140  =1: TRI 2,0: ARC TO t(f+1,x),t(f+1,y),-PI/rc
1150  =2: TRI 2,0: TRI 3,1
1160  =3: ARC TO Mx,My,+PI/rc: TRI 3,0
1170  =4: REMark not implemented yet.
1180  =5: ARC TO Mx,My,+PI/rc: TRI 3,1
1190  =6: TRI 2,1: TRI 3,0
1200  =7: TRI 2,1: ARC TO t(f+1,x),t(f+1,y),-PI/rc
1210  =8: TRI 1,1
1220 END SELect
1230 END FOR f : REMark LINE TO t(3,x),t(3,y): REMark only for closed loops !
1240 END DEFine DRAW
1250 :
1260 DEFine PROCedure TRI(TR,CW)
1270 REMark Find perpendicular cut-points using simultaneous equations :
1280 xa=L(TR,1,x):ya=L(TR,1,y): xb=L(TR,2,x): yb=L(TR,2,y): xc=L(TR,3,x):yc=L(TR,3,y)
1290 xd=L(TR,4,x):yd=L(TR,4,y): BCx=xb-xc: BCy=yb-yc: MCx=BCx/2: MCy=BCy/2: Mx=xb-MCx
1300 REMark use simultaneous equations to determine cut-points of bisextrices :
1310 px=xa-xb: py=ya-yb: qx=xc-xd: qy=yc-yd: g1=1E-6: g2=1E-6
1320 IF px=0: px=1E-6: END IF : g1=py/px
1330 IF qx=0: qx=1E-6: END IF : g2=qy/qx
1340 k1=ya-xa*g1: k2=yc-xc*g2: gg=g1-g2: My=yb-MCy
1350 :: IF gg=0: gg=1E-6: END IF : ix=(k2-k1)/gg: iy=g1*ix+k1
1360 Maj=SQRT(MCx*MCx+MCy*MCy): REMark Major axis of ellipse.
1370 IF TR=2: ix=(ix+bx)/2: iy=(iy+by)/2
1380 IF TR=3: ix=(ix+cx)/2: iy=(iy+cy)/2
1390 :
1400 REMark find 'projective parameters' for each elliptic arc :
1410 mix=ix-Mx: miy=iy-My: im=SQRT(mix*mix+miy*miy): Min=Maj*fc: lim=2*Min
1420 bm=SQRT(BCx*BCx+BCy*BCy)/2: ibx=ix-xb: iby=iy-yb: ib=SQRT(ibx*ibx+iby*iby)
1430 dv=1E-6
1440 IF 0<>(ib*bm): dv=(bm*bm+ib*ib-im*im)/(2*ib*bm)
1450 IF ABS(dv)>=1: adv=ACOS(.9999): ELSE adv=ACOS(dv)
1460 sdv=SIN(adv): hi=ib*sdv
1470 :
1480 REMark determine ellipse eccentricity.
1490 IF lim<>0: ec=hi/lim: ELSE ec=hi/1E-6
1500 sl=TR
1510 SELect ON sl: =1: xE=Mx: yE=My: =2: xE=bx: yE=by: =3: xE=cx: yE=cy
1520 IF hi>lim THEN
1530   IF hi<>0: ek=lim/hi: ELSE ek=lim/1E-6
1540   xx=ek*mix: Ey=ek*miy: ix=xE+xx: iy=yE+Ey: ec=fc
1550 END IF
1560 ect=(TRg(f+1))*ec
1570 IF Maj<>0: ecc=(Min/Maj)*(Min/Maj)*ect*fc: ELSE ecc=1E-6*ect*fc
1580  REMark IF ecc<3E-2: ecc=3E-2
1590 ELIPTICS
1600 END DEFine TRI
1610 :
1620 DEFine PROCedure ELIPTICS
1630 LOCal f,j,ct: ro=0: h=prec: IF xc<xb: ro=180
1640 REMark
1650 q=h+1: IF h<>0: st=360/h: ELSE st=360/1E-6
1660 IF MCx<>0: rot=DEG(ATAN(MCy/MCx)): ELSE rot=DEG(ATAN(MCy/1E-6))
1670 rot=rot+ro: h=prec: hh=h/2: rot=RAD(rot): ct=0
1680 :
1690 REMark Swing all interpolated points around cut-points:
1700 SS=-st: AA=180-st: ZZ=st*0: IF CW=0: SS=st: AA=-180+st: ZZ=-ZZ*0: ct=hh
1710 FOR f=AA TO ZZ STEP SS
1720     REMark IF f=90 OR f=-90: dud=f: REM not yet implemented
1730     ct=ct+1: j=RAD(f): Crx=Maj*COS(j)
1740     ROTATE pp,Crx,0: cry=Maj*SIN(j)*ecc: ROTATE ee,Crx,cry
1750 END FOR f
1760 :
1770 REMark Draw all curve segments linking elliptic dots :
1780 IF CW<>0: j=0: ct=hh: ELSE : j=hh: ct=h
1790 x1=ix: y1=iy
1800 FOR f=j+1 TO j+hh
1810  x2=u(2,f,x): y2=u(2,f,y): x3=u(1,f,x): y3=u(1,f,y): x4=u(1,ct,x): y4=u(1,ct,y)
1820  xp=x1-x2: yp=y1-y2: xq=x3-x4: yq=y3-y4: IF xp<>0: g1=yp/xp: ELSE g1=yp/1E-6
1830  IF xq<>0: g2=yq/xq: ELSE g2=yq/1E-6
1840  k1=y1-x1*g1: gg=g1-g2: IF gg=0: gg=1E-6: END IF : m=(y3-x3*g2-k1)/gg
1850  n=g1*m+k1:  IF 0==(xp+1): m=x1: n=y3+g2*(x1-x3)
1860              IF 0==(xq+1): m=x3: n=y1+g1*(x3-x1)
1870  LINE TO m,n: IF pr: INK 7: CIRCLE m,n,1.8: INK 4
1875 ct=ct-1
1880 END FOR f
1890 END DEFine ELIPTICS
1900 :
1910 DEFine PROCedure ROTATE(nn,rx,ry)
1920 LOCal rh,a,b,c,d,h,n,r
1930 REMark projectional rotation using correct sign types :
1940 c=(rx>0)-(rx<0): d=(ry>0)-(ry<0): n=-1
1950 h=SQRT(rx*rx+ry*ry): IF h=0: h=1E-6: END IF : a=ABS(ASIN(ry/h))
1960 SELect ON c
1970 =-1: SELect ON d: =-1: a=PI+a: =0: a=PI: =+1: a=PI-a
1980 =0 : SELect ON d: =-1: a=Pl  : =0: a=0 : =+1: a=Ph
1990 =+1: SELect ON d: =-1: a=Pw-a: =0: a=0 : =+1: a=a
2000 END SELect : b=a+rot: c=1: d=1: xx=0: yy=0
2010 REPeat r: IF b<0: b=b+Pw: ELSE EXIT r
2020 IF b>=Pw:b=b-Pw: GO TO 2020
2030 IF (0==(b+1)) OR (b==Pw): xx=h:  GO TO 2080
2040 IF b>Pl : b=Pw-b : d=n: GO TO 2080
2050 IF b==PI: xx=-h  : GO TO 2080
2060 IF b==Pl: yy=-h: GO TO 2080
2070 IF b>PI : b=b-PI: c=n: d=n
2080 xx=h*COS(b)*c: yy=h*SIN(b)*d
2090 u(nn,ct,x)=Mx+xx: u(nn,ct,y)=My+yy
2100 END DEFine
2110 :
2120 DEFine PROCedure INIT
2130 WINDOW 512,256,0,0: SCALE 256,-148,-128: PAPER 0: INK 7: CLS
2140 WINDOW#2,512,206,0,0
2150 sg$='++ +0 +- 0+ 00 0- -+ -0 -- ': sig$='-0+'
2160 x=1: y=2: azt=3: trn=4: typ=5: Ph=PI/2: Pl=Ph*3: Pw=PI*2: ee=1: pp=2
2170 dots=RND(dotss)+4+1: DIM t(dots+4+1,typ),L(3,4,2),u(pp,prec,y): fc=.685
2180 t(0,x)=-180: t(0,y)=0: REMark (Fictive closed-loop starting point).
2190 : fx=256/(dots*10): fy=96-dots: AT 0,1: PRINT dots-1,prec,: INK 2
2200 :
2210 REMark here is the program's 'point data' :
2220 FOR f=1 TO dots: t(f,x)=t(f-1,x)+RND(5 TO 19)*fx+2
2230 FOR f=1 TO dots: t(f,y)=(t(f-1,y)+RND(fy)-RND(fy))+1
2240 :
2250 REMark Extra code for 'looping' data :
2260 IF dots=4: RESTORE : CIRCLE 0,0,56: FOR f=1 TO 4: READ t(f,x),t(f,y)
2270 DATA -40,-40,-40,40, 40,40, 40,-40
2280 :
2290 REMark Horizontal or vertical lines are 'nudged' :
2300 FOR f=2 TO dots: IF t(f,x)=t(f-1,x): t(f,x)=t(f,x)+.1
2310 FOR f=2 TO dots: IF t(f,y)=t(f-1,y): t(f,y)=t(f,y)+.1
2320 :
2330 REMark Detremine auto-scaling parameters:
2340 Min=9999: FOR f=1 TO dots: IF t(f,y)<Min: Min=t(f,y)
2350 Maj=-999: FOR f=1 TO dots: IF t(f,y)>Maj: Maj=t(f,y)
2360 IF dots>4:  sca=(Maj+ABS(Min))*1.5: SCALE sca*2,t(1,x)-2,-sca
2370 :
2380 REMark Draw the dots:
2390 FOR f=2 TO dots: FILL 1: CIRCLE t(f,x),t(f,y),5: FILL 0
2400 :
2410 REMark Allow array space for closed loops:
2420 FOR f=1 TO 4: t(f+dots,x)=t(f,x): t(f+dots,y)=t(f,y)
2430 END DEFine
2440 :
